﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;

namespace SampleProgram
{
    class PvPrnWin32API_x86
    {
        [DllImport("PvPrnWin32API.dll")]
        public static extern int ConnectPrinter(
            int nInterface,
            [MarshalAs(UnmanagedType.LPStr)]string szPortName,
            int nBaudRate,
            int nDataBits,
            int nParity,
            int nStopBits,
            int nFlowControl);

        [DllImport("PvPrnWin32API.dll")]
        public static extern int ConnectPrinterW(
            int nInterface,
            [MarshalAs(UnmanagedType.LPWStr)]string szPortName,
            int nBaudRate,
            int nDataBits,
            int nParity,
            int nStopBits,
            int nFlowControl);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool DisconnectPrinter();

        [DllImport("PvPrnWin32API.dll")]
        public static extern int GetPrinterDPI();

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool Print1DBarcode(int nHorizontalPos,
                                                 int nVerticalPos,
                                                 int nBarcodeType,
                                                 int nNarrowBarWidth,
                                                 int nWideBarWidth,
                                                 int nBarcodeHeight,
                                                 int nRotation,
                                                 int nHRI,
                                                 [MarshalAs(UnmanagedType.LPStr)]string pData);
         
        [DllImport("PvPrnWin32API.dll")]
        public static extern bool Print1DBarcode(int nHorizontalPos,
                                                 int nVerticalPos,
                                                 int nBarcodeType,
                                                 int nNarrowBarWidth,
                                                 int nWideBarWidth,
                                                 int nBarcodeHeight,
                                                 int nRotation,
                                                 int nHRI,
                                                 Byte[] pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintDeviceFont(int nHorizontalPos,
                                                  int nVerticalPos,
                                                  int nFontName,
                                                  int nHorizontalMulti,
                                                  int nVerticalMulti,
                                                  int nRotation,
                                                  bool bBold,
                                                  [MarshalAs(UnmanagedType.LPStr)]string szText);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintDeviceFontW(//int nCodePage, 
                                                   int nHorizontalPos,
                                                   int nVerticalPos,
                                                   int nFontName,
                                                   int nHorizontalMulti,
                                                   int nVerticalMulti,
                                                   int nRotation,
                                                   bool bBold,
                                                   [MarshalAs(UnmanagedType.LPWStr)]string szText);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool SetConfigOfPrinter(int nSpeed,
                                                     int nDensity,
                                                     int nOrientation,
                                                     bool bAutoCut,
                                                     int nCuttingPeriod,
                                                     bool bBackFeeding);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool Prints(int nLabelSet, int nCopiesOfEachLabel);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool SetCharacterset(int nInternationalCharacterSet, int nCodepage);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool SetPaper(int nHorizontalMagin,
                                           int nVerticalMargin,
                                           int nPaperWidth,
                                           int nPaperLength,
                                           int nMediaType,
                                           int nOffSet,
                                           int nGapLengthORThicknessOfBlackLine);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool ClearBuffer();

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintBlock(int nHorizontalStartPos,
                                             int nVerticalStartPos,
                                             int nHorizontalEndPos,
                                             int nVerticalEndPos,
                                             int nOption,
                                             int nThickness);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintCircle(int nHorizontalStartPos,
                                             int nVerticalStartPos,
                                             int nDiameter,
                                             int nMulti);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintDirect([MarshalAs(UnmanagedType.LPStr)]string pDirectData, bool bAddCrLf);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintTrueFont(
                                        int nXPos,
                                        int nYPos,
                                        [MarshalAs(UnmanagedType.LPStr)]string strFontName,
                                        int nFontSize,
                                        int nRotaion,
                                        bool bItalic,
                                        bool bBold,
                                        bool bUnderline,
                                        [MarshalAs(UnmanagedType.LPStr)]string strText, bool bDataCompression);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintTrueFontW(
                                        int nXPos,
                                        int nYPos,
                                        [MarshalAs(UnmanagedType.LPWStr)]string strFontName,
                                        int nFontSize,
                                        int nRotaion,
                                        bool bItalic,
                                        bool bBold,
                                        bool bUnderline,
                                        [MarshalAs(UnmanagedType.LPWStr)]string strText, bool bDataCompression);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintVectorFont(
                                                    int nXPos,
                                                    int nYPos,
                                                    [MarshalAs(UnmanagedType.LPStr)]string FontSelection,
                                                    int FontWidth,
                                                    int FontHeight,
                                                    [MarshalAs(UnmanagedType.LPStr)]string RightSideCharSpacing,
                                                    bool bBold,
                                                    bool ReversePrinting,
                                                    bool TextStyle,
                                                    int Rotation,
                                                    [MarshalAs(UnmanagedType.LPStr)]string TextAlignment,
                                                    int TextDirection,
                                                    [MarshalAs(UnmanagedType.LPStr)]string pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintVectorFontW( //int nCodePage,
                                                    int nXPos,
                                                    int nYPos,
                                                    [MarshalAs(UnmanagedType.LPStr)]string FontSelection,
                                                    int FontWidth,
                                                    int FontHeight,
                                                    [MarshalAs(UnmanagedType.LPStr)]string RightSideCharSpacing,
                                                    bool bBold,
                                                    bool ReversePrinting,
                                                    bool TextStyle,
                                                    int Rotation,
                                                    [MarshalAs(UnmanagedType.LPStr)]string TextAlignment,
                                                    int TextDirection,
                                                    [MarshalAs(UnmanagedType.LPWStr)]string pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintQRCode(int nXPos,
                           int nYPos,
                           int nModel,
                           int nECCLevel,
                           int nSize,
                           int nRotation,
                           [MarshalAs(UnmanagedType.LPStr)]string pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintPDF417(int nXPos,
                            int nYPos,
                            int nMaxRow,
                            int nMaxCol,
                            int nECLevel,
                            int nDataType,
                            bool bHRI,
                            int nOriginPoint,
                            int nModuleWidth,
                            int nBarHeight,
                            int nRotation,
                           [MarshalAs(UnmanagedType.LPStr)]string pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintDataMatrix(int nXPos,
                           int nYPos,
                           int nSize,
                           bool bReverse,
                           int nRotation,
                           [MarshalAs(UnmanagedType.LPStr)]string pData);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintBitmapFile(int nHorizontalStartPos,
                                                int nVerticalStartPos,
                                                [MarshalAs(UnmanagedType.LPStr)]string pBitmapFilename,
                                                int nDither,
                                                bool bDataCompression);

        [DllImport("PvPrnWin32API.dll")]
        public static extern bool PrintBitmapFileW(int nHorizontalStartPos,
                                                 int nVerticalStartPos,
                                                 [MarshalAs(UnmanagedType.LPWStr)]string pBitmapFilename,
                                                 int nDither,
                                                 bool bDataCompression);

        [DllImport("PvPrnWin32API.dll")]
        public static extern int CheckStatus();

    }
}
