﻿Imports System.Runtime.InteropServices
Imports System.Text

Public Module mdlPvPrnWin32API_x64

#Region " DLL API Function "

    Public Declare Function ConnectPrinter_x64 Lib "PvPrnWin32API_x64.dll" Alias "ConnectPrinter" ( _
                            ByVal nInterface As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal szPortName As String, _
                            ByVal nBaudRate As Integer, _
                            ByVal nDataBits As Integer, _
                            ByVal nParity As Integer, _
                            ByVal nStopBits As Integer, _
                            ByVal nFlowControl As Integer) As Integer

    Public Declare Function ConnectPrinterW_x64 Lib "PvPrnWin32API_x64.dll" Alias "ConnectPrinterW" ( _
                            ByVal nInterface As Integer, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal szPortName As String, _
                            ByVal nBaudRate As Integer, _
                            ByVal nDataBits As Integer, _
                            ByVal nParity As Integer, _
                            ByVal nStopBits As Integer, _
                            ByVal nFlowControl As Integer) As Integer

    Public Declare Function DisconnectPrinter_x64 Lib "PvPrnWin32API_x64.dll" Alias "DisconnectPrinter" () As Boolean

    Public Declare Function GetPrinterDPI_x64 Lib "PvPrnWin32API_x64.dll" Alias "GetPrinterDPI" () As Integer

    Public Declare Function Print1DBarcode_x64 Lib "PvPrnWin32API_x64.dll" Alias "Print1DBarcode" ( _
                            ByVal nHorizontalPos As Integer, _
                            ByVal nVerticalPos As Integer, _
                            ByVal nBarcodeType As Integer, _
                            ByVal nNarrowBarWidth As Integer, _
                            ByVal nWideBarWidth As Integer, _
                            ByVal nBarcodeHeight As Integer, _
                            ByVal nRotation As Integer, _
                            ByVal nHRI As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal pData As String) As Boolean

    Public Declare Function Print1DBarcode_x64 Lib "PvPrnWin32API_x64.dll" Alias "Print1DBarcode" ( _
                            ByVal nHorizontalPos As Integer, _
                            ByVal nVerticalPos As Integer, _
                            ByVal nBarcodeType As Integer, _
                            ByVal nNarrowBarWidth As Integer, _
                            ByVal nWideBarWidth As Integer, _
                            ByVal nBarcodeHeight As Integer, _
                            ByVal nRotation As Integer, _
                            ByVal nHRI As Integer, _
                            ByVal pData As Byte()) As Boolean

    Public Declare Function PrintDeviceFont_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintDeviceFont" ( _
                            ByVal nHorizontalPos As Integer, _
                            ByVal nVerticalPos As Integer, _
                            ByVal nFontName As Integer, _
                            ByVal nHorizontalMulti As Integer, _
                            ByVal nVerticalMulti As Integer, _
                            ByVal nRotation As Integer, _
                            ByVal bBold As Boolean, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal szText As String) As Boolean

    Public Declare Function PrintDeviceFontW_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintDeviceFontW" ( _
                            ByVal nCodePage As Integer, _
                            ByVal nHorizontalPos As Integer, _
                            ByVal nVerticalPos As Integer, _
                            ByVal nFontName As Integer, _
                            ByVal nHorizontalMulti As Integer, _
                            ByVal nVerticalMulti As Integer, _
                            ByVal nRotation As Integer, _
                            ByVal bBold As Boolean, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal szText As String) As Boolean

    Public Declare Function SetConfigOfPrinter_x64 Lib "PvPrnWin32API_x64.dll" Alias "SetConfigOfPrinter" ( _
                            ByVal nSpeed As Integer, _
                            ByVal nDensity As Integer, _
                            ByVal nOrientation As Integer, _
                            ByVal bAutoCut As Boolean, _
                            ByVal nCuttingPeriod As Integer, _
                            ByVal bBackFeeding As Boolean) As Boolean

    Public Declare Function Prints_x64 Lib "PvPrnWin32API_x64.dll" Alias "Prints" ( _
                            ByVal nLabelSet As Integer, _
                            ByVal nCopiesOfEachLabel As Integer) As Boolean

    Public Declare Function SetCharacterset_x64 Lib "PvPrnWin32API_x64.dll" Alias "SetCharacterset" ( _
                     ByVal nInternationalCharacterSet As Integer, _
                     ByVal nCodepage As Integer) As Boolean

    Public Declare Function SetPaper_x64 Lib "PvPrnWin32API_x64.dll" Alias "SetPaper" ( _
                            ByVal nHorizontalMagin As Integer, _
                            ByVal nVerticalMargin As Integer, _
                            ByVal nPaperWidth As Integer, _
                            ByVal nPaperLength As Integer, _
                            ByVal nMediaType As Integer, _
                            ByVal nOffSet As Integer, _
                            ByVal nGapLengthORThicknessOfBlackLine As Integer) As Boolean

    Public Declare Function ClearBuffer_x64 Lib "PvPrnWin32API_x64.dll" Alias "ClearBuffer" () As Boolean

    Public Declare Function PrintBlock_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintBlock" ( _
                            ByVal nHorizontalStartPos As Integer, _
                            ByVal nVerticalStartPos As Integer, _
                            ByVal nHorizontalEndPos As Integer, _
                            ByVal nVerticalEndPos As Integer, _
                            ByVal nOption As Integer, _
                            ByVal nThickness As Integer) As Boolean

    Public Declare Function PrintCircle_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintCircle" ( _
                            ByVal nHorizontalStartPos As Integer, _
                            ByVal nVerticalStartPos As Integer, _
                            ByVal nDiameter As Integer, _
                            ByVal nMulti As Integer) As Boolean

    Public Declare Function PrintDirect_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintDirect" ( _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal pDirectData As String, _
                            ByVal bAddCrLf As Boolean) As Boolean

    Public Declare Function PrintTrueFont_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintTrueFont" ( _
                            ByVal nXPos As Integer, _
                            ByVal nYPos As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal strFontName As String, _
                            ByVal nFontSize As Integer, _
                            ByVal nRotaion As Integer, _
                            ByVal bItalic As Boolean, _
                            ByVal bBold As Boolean, _
                            ByVal bUnderline As Boolean, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal strText As String, _
                            ByVal bDataCompression As Boolean) As Boolean

    Public Declare Function PrintTrueFontW_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintTrueFontW" ( _
                            ByVal nXPos As Integer, _
                            ByVal nYPos As Integer, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal strFontName As String, _
                            ByVal nFontSize As Integer, _
                            ByVal nRotaion As Integer, _
                            ByVal bItalic As Boolean, _
                            ByVal bBold As Boolean, _
                            ByVal bUnderline As Boolean, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal strText As String, _
                            ByVal bDataCompression As Boolean) As Boolean

    Public Declare Function PrintVectorFont_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintVectorFont" ( _
                            ByVal nXPos As Integer, _
                            ByVal nYPos As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal FontSelection As String, _
                            ByVal FontWidth As Integer, _
                            ByVal FontHeight As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal RightSideCharSpacing As String, _
                            ByVal bBold As Boolean, _
                            ByVal ReversePrinting As Boolean, _
                            ByVal TextStyle As Boolean, _
                            ByVal Rotation As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal TextAlignment As String, _
                            ByVal TextDirection As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal pData As String) As Boolean

    Public Declare Function PrintVectorFontW_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintVectorFontW" ( _
                            ByVal nXPos As Integer, _
                            ByVal nYPos As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal FontSelection As String, _
                            ByVal FontWidth As Integer, _
                            ByVal FontHeight As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal RightSideCharSpacing As String, _
                            ByVal bBold As Boolean, _
                            ByVal ReversePrinting As Boolean, _
                            ByVal TextStyle As Boolean, _
                            ByVal Rotation As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal TextAlignment As String, _
                            ByVal TextDirection As Integer, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal pData As String) As Boolean

    Public Declare Function PrintPDF417_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintPDF417" ( _
                                ByVal nXPos As Integer, _
                                ByVal nYPos As Integer, _
                                ByVal nMaxRow As Integer, _
                                ByVal nMaxCol As Integer, _
                                ByVal nECLevel As Integer, _
                                ByVal nDataType As Integer, _
                                ByVal bHRI As Boolean, _
                                ByVal nOriginPoint As Integer, _
                                ByVal nModuleWidth As Integer, _
                                ByVal nBarHeight As Integer, _
                                ByVal nRotation As Integer, _
                                <MarshalAs(UnmanagedType.LPStr)> ByVal pData As String) _
                                As Boolean

    Public Declare Function PrintQRCode_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintQRCode" ( _
                            ByVal nXPos As Integer, _
                            ByVal nYPos As Integer, _
                            ByVal nModel As Integer, _
                            ByVal nECCLevel As Integer, _
                            ByVal nSize As Integer, _
                            ByVal nRotation As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal pData As String) As Boolean

    Public Declare Function PrintDataMatrix_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintDataMatrix" ( _
                                    ByVal nXPos As Integer, _
                                    ByVal nYPos As Integer, _
                                    ByVal nSize As Integer, _
                                    ByVal bReverse As Boolean, _
                                    ByVal nRotation As Integer, _
                                    <MarshalAs(UnmanagedType.LPStr)> ByVal pData As String) _
                                    As Boolean

    Public Declare Function PrintBitmapFile_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintBitmapFile" ( _
                            ByVal nHorizontalStartPos As Integer, _
                            ByVal nVerticalStartPos As Integer, _
                            <MarshalAs(UnmanagedType.LPStr)> ByVal pBitmapFilename As String, _
                            ByVal nDither As Integer, _
                            ByVal bDataCompression As Boolean) As Boolean

    Public Declare Function PrintBitmapFileW_x64 Lib "PvPrnWin32API_x64.dll" Alias "PrintBitmapFileW" ( _
                            ByVal nHorizontalStartPos As Integer, _
                            ByVal nVerticalStartPos As Integer, _
                            <MarshalAs(UnmanagedType.LPWStr)> ByVal pBitmapFilename As String, _
                            ByVal nDither As Integer, _
                            ByVal bDataCompression As Integer) As Boolean

    Public Declare Function CheckStatus_x64 Lib "PvPrnWin32API_x64.dll" Alias "CheckStatus" () As Integer


#End Region


End Module
