
// SampleProgramDlg.h : header file
//

#pragma once
#include "afxcmn.h"



// CSampleProgramDlg dialog
class CSampleProgramDlg : public CDialog
{
// Construction
public:
	CSampleProgramDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_SAMPLEPROGRAM_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	void InitControls();
	void EnableIFControls(int nInterface);
	BOOL Connect();
	void SendPrinterSettingCommand();
	CString GetStatusMsg(int nStatus);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedRadioIF(UINT msg);
protected:
	CIPAddressCtrl m_Lan_IPAddr;
	CComboBox	m_cmbCOM_Stopbits;
	CComboBox	m_cmbCOM_Databits;
	CComboBox	m_cmbCOM_Baudrate;
	CComboBox	m_cmbCOM_Parity;
	CComboBox	m_cmbCOM_Port;
	CComboBox	m_cmbLPT_Port;
	CComboBox	m_cmbDensity;
	CComboBox	m_cmbSpeed;
	
public:
	afx_msg void OnEnKillfocusEditPWidth();
	afx_msg void OnEnKillfocusEditPHeight();
	afx_msg void OnEnKillfocusEditMarginX();
	afx_msg void OnEnKillfocusEditMarginY();
	afx_msg void OnBnClickedButtonPrint();
	afx_msg void OnBnClickedButtonStatus();
};
