﻿Module mdlPvPrnWin32API

#Region " Constant variables "

    Public Const ISerial As Integer = 0
    Public Const IParallel As Integer = 1
    Public Const IUsb As Integer = 2
    Public Const ILan As Integer = 4    ' Network (Wi-Fi, Ethernet)
    Public Const IBluetooth As Integer = 5

    Enum SLCS_HRI
        HRI_NOT_PRINT = 0
        HRI_BELOW_SIZE1 = 1
        HRI_ABOVE_SIZE1 = 2
        HRI_BELOW_SIZE2 = 3
        HRI_ABOVE_SIZE2 = 4
        HRI_BELOW_SIZE3 = 5
        HRI_ABOVE_SIZE3 = 6
        HRI_BELOW_SIZE4 = 7
        HRI_ABOVE_SIZE4 = 8
    End Enum

    Enum SLCS_PDF417_ECC_LEVEL
        PDF417_ECC_LEVEL0 = 0
        PDF417_ECC_LEVEL1 = 1
        PDF417_ECC_LEVEL2 = 2
        PDF417_ECC_LEVEL3 = 3
        PDF417_ECC_LEVEL4 = 4
        PDF417_ECC_LEVEL5 = 5
        PDF417_ECC_LEVEL6 = 6
        PDF417_ECC_LEVEL7 = 7
        PDF417_ECC_LEVEL8 = 8
    End Enum

    Enum SLCS_CIRCLE_SIZE
        CIRCLE_SIZE_1 = 1 ' 40 x 40 in dot unit
        CIRCLE_SIZE_2 = 2 ' 56 x 56 in dot unit
        CIRCLE_SIZE_3 = 3 ' 72 x 72 in dot unit
        CIRCLE_SIZE_4 = 4 ' 88 x 88 in dot unit
        CIRCLE_SIZE_5 = 5 ' 104 x 104 in dot unit
        CIRCLE_SIZE_6 = 6     ' 168 x 168 in dot unit
    End Enum

    Enum SLCS_PDF417_DATA_TYPE
        PDF417_TEXT_TYPE = 0
        PDF417_NUMERIC_TYPE = 1
        PDF417_BINARY_TYPE = 2
    End Enum

    Enum SLCS_INTERNATIONAL_CHARSET As Integer
        ICS_USA = 0
        ICS_FRANCE = 1
        ICS_GERMANY = 2
        ICS_UK = 3
        ICS_DENMARK_I = 4
        ICS_SWEDEN = 5
        ICS_ITALY = 6
        ICS_SPAIN_I = 7
        ICS_NORWAY = 8
        ICS_DENMARK_II = 9
        ICS_JAPAN = 10
        ICS_SPAIN_II = 11
        ICS_LATIN_AMERICA = 12
        ICS_KOREA = 13
        ICS_SLOVENIA_CROATIA = 14
        ICS_CHINA = 15
    End Enum

    Enum SLCS_CODEPAGE As Integer
        FCP_CP437 = 0
        FCP_CP850 = 1 '	OEM Multilingual Latin 1; Western European (DOS)
        FCP_CP852 = 2 '	OEM Latin 2; Central European (DOS)
        FCP_CP860 = 3 '	OEM Portuguese; Portuguese (DOS)
        FCP_CP863 = 4 '	OEM French Canadian; French Canadian (DOS)
        FCP_CP865 = 5 '	OEM Nordic; Nordic (DOS)
        FCP_CP1252 = 6 'ANSI Latin 1; Western European (Windows)
        FCP_CP857 = 8 '	OEM Turkish; Turkish (DOS)
        FCP_CP737 = 9 '	OEM Greek (formerly 437G); Greek (DOS) 
        FCP_CP1250 = 10 ' ANSI Central European; Central European (Windows)// MPOS_CODEPAGE_CP1250 ??
        FCP_CP1253 = 11 ' ANSI Greek; Greek (Windows)
        FCP_CP1254 = 12 ' ANSI Turkish; Turkish (Windows)
        FCP_CP855 = 13 ' OEM Cyrillic (primarily Russian)
        FCP_CP862 = 14 ' OEM Hebrew; Hebrew (DOS)
        FCP_CP866 = 15 ' OEM Russian; Cyrillic (DOS)
        FCP_CP1251 = 16 ' ANSI Cyrillic; Cyrillic (Windows) 
        FCP_CP1255 = 17 ' ANSI Hebrew; Hebrew (Windows) 
        FCP_CP928 = 18 ' Greek
        FCP_CP775 = 20 ' OEM Baltic; Baltic (DOS) 
        FCP_CP1257 = 21 ' ANSI Baltic; Baltic (Windows)
        FCP_CP858 = 22 '  OEM Multilingual Latin 1 + Euro symbol
    End Enum

    Enum SLCS_ROTATION As Integer
        ROTATE_0 = 0
        ROTATE_90 = 1
        ROTATE_180 = 2
        ROTATE_270 = 3
    End Enum

    '	Device Fonts
    Enum SLCS_DEVICE_FONT As Integer
        ENG_9X15 = 0
        ENG_12X20 = 1
        ENG_16X25 = 2
        ENG_19X30 = 3
        ENG_24X38 = 4
        ENG_32X50 = 5
        ENG_48X76 = 6
        ENG_22X34 = 7
        ENG_28X44 = 8
        ENG_37X58 = 9
        KOR_16X16 = &H61
        KOR_24X24 = &H62
        KOR_20X20 = &H63
        KOR_20X26 = &H65
        KOR_38X38 = &H66
        JPN_ShiftJIS = &H6A
        CHN_GB2312 = &H6D
        CHN_BIG5 = &H6E
    End Enum

    Enum SLCS_BARCODE As Integer
        CODE39 = 0
        CODE128 = 1
        I2OF5 = 2
        CODABAR = 3
        CODE93 = 4
        UPC_A = 5
        UPC_E = 6
        EAN13 = 7
        EAN8 = 8
        UCC_EAN128 = 9
    End Enum

    Enum SLCS_BLOCK_OPTION As Integer
        LINE_OVER_WRITING = 0
        LINE_EXCLUSIVE_OR = 1
        LINE_DELETE = 2
        SLOPE = 3
        BOX = 4
    End Enum

    Enum SLCS_DATAMATRIX_SIZE As Integer
        DATAMATRIX_SIZE_1 = 1
        DATAMATRIX_SIZE_2 = 2
        DATAMATRIX_SIZE_3 = 3
        DATAMATRIX_SIZE_4 = 4
    End Enum

    Enum SLCS_QRCODE_MODEL As Integer
        QRMODEL_1 = 1
        QRMODEL_2 = 2
    End Enum


    Enum SLCS_QRCODE_SIZE As Integer
        QRSIZE_1 = 1
        QRSIZE_2 = 2
        QRSIZE_3 = 3
        QRSIZE_4 = 4
        QRSIZE_5 = 5
        QRSIZE_6 = 6
        QRSIZE_7 = 7
        QRSIZE_8 = 8
        QRSIZE_9 = 9
    End Enum

    Enum SLCS_QRCODE_ECC_LEVEL As Integer
        QRECCLEVEL_L = 1 ' 7%
        QRECCLEVEL_M = 2 ' 15%
        QRECCLEVEL_Q = 3 ' 25%
        QRECCLEVEL_H = 4 ' 30%
    End Enum

    Enum SLCS_ORIENTATION As Integer
        TOP2BOTTOM = 0
        BOTTOM2TOP = 1
    End Enum


    Enum SLCS_MEDIA_TYPE As Integer
        GAP = 0
        CONTINUOUS = 1
        BLACKMARK = 2
    End Enum


    Enum SLCS_PRINT_SPEED As Integer
        PRINTER_SETTING_SPEED = -1
        PRINTER_SPEED_0 = 0
        PRINTER_SPEED_1 = 1
        PRINTER_SPEED_2 = 2
        PRINTER_SPEED_3 = 3
        PRINTER_SPEED_4 = 4
        PRINTER_SPEED_5 = 5
        PRINTER_SPEED_6 = 6
        PRINTER_SPEED_7 = 7
        PRINTER_SPEED_8 = 8
        PRINTER_SPEED_9 = 9
        PRINTER_SPEED_10 = 10
        PRINTER_SPEED_11 = 11
        PRINTER_SPEED_12 = 12
    End Enum

    Enum SLCS_DITHER_OPTION As Integer
        DITHER_NONE = -1
        DITHER_1 = 0
        DITHER_2 = 1
        DITHER_3 = 6
        DITHER_4 = 7
    End Enum

    ' Font Selection
    Public Const ASCII As String = "U"
    Public Const KS5601 As String = "K"
    Public Const BIG5 As String = "B"
    Public Const GB2312 As String = "G"
    Public Const ShiftJIS As String = "J"


    ' Font Alignment
    Public Const LEFTALIGN As String = "L"
    Public Const RIGHTALIGN As String = "R"
    Public Const CENTERALIGN As String = "C"

    ' Font Direction
    Public Const LEFTTORIGHT As Integer = 0
    Public Const RIGHTTOLEFT As Integer = 1

    ' Error code
    Public Const ERR_CODE_NO_ERROR As Integer = 0
    Public Const ERR_CODE_WAIT_FOR_LABEL_TAKEN As Integer = 2
    Public Const ERR_CODE_BOARD_OVER_HEAT As Integer = 4
    Public Const ERR_CODE_AUTO_SENSING As Integer = 8
    Public Const ERR_CODE_TPH_OVER_HEAT As Integer = 16
    Public Const ERR_CODE_MOTOR_OVER_HEAT As Integer = 32
    Public Const ERR_CODE_COVER_OPEN As Integer = 64
    Public Const ERR_CODE_PAPER_EMPTY As Integer = 128

    Public Const ERR_CODE_PAUSED_LABEL As Integer = 256
    Public Const ERR_CODE_PRINTING_LABEL As Integer = 512
    Public Const ERR_CODE_BUILDING_LABEL As Integer = 1024

    Public Const ERR_CODE_UNABLE_CONNECT As Integer = -1
    Public Const ERR_CODE_UNKNOWN As Integer = -2

#End Region


#Region " ETC "

    ' 숫자 입력 처리
    Public Sub pInputValidateDigit(ByRef e As System.Windows.Forms.KeyPressEventArgs)
        If e.KeyChar = "." Then
            e.Handled = True
        ElseIf e.KeyChar = Convert.ToChar(System.Windows.Forms.Keys.Back) OrElse e.KeyChar = Convert.ToChar(System.Windows.Forms.Keys.Delete) Then
            e.Handled = False
        ElseIf Char.IsDigit(e.KeyChar) = True Then
            e.Handled = False
        Else
            e.Handled = True
        End If
    End Sub

    ' 숫자 입력 처리(핸들, 소숫점 포함여부) 
    Public Sub pInputValidateFloat(ByRef e As System.Windows.Forms.KeyPressEventArgs, ByVal sender As Object)
        Dim nPreLen As Integer = 4    ' 정수부 길이
        Dim nPostLen As Integer = 3   ' 소수부 길이 

        '백스페이스는 그냥 허용
        If e.KeyChar = Convert.ToChar(System.Windows.Forms.Keys.Back) Then Exit Sub

        'sender 로부터 텍스트 박스 구함
        Dim editor As TextBox = sender

        '소숫점의 점(dot)이 포함되어 있는지 여부.
        '단, 현재 selection 상태인 텍스트에 점이 포함되어 있으면 비포함으로 간주
        Dim bDotContains As Boolean = editor.Text.Contains(".") AndAlso Not editor.SelectedText.Contains(".")

        '전체 길이 체크를 위한 변수(selection 길이는 뺀다)
        Dim nTextLen As Integer = editor.Text.Length - editor.SelectedText.Length
        '현재 커서 위치
        Dim nCursor As Integer = editor.SelectionStart

        '점과 숫자 이외의 값은 받아들이지 않음.
        If Not e.KeyChar = "." AndAlso Not Char.IsDigit(e.KeyChar) Then
            e.Handled = True
            '소숫점 이하 값이 없는 경우 - 2010.12.29 추가
        ElseIf e.KeyChar = "." AndAlso nPostLen < 1 Then
            e.Handled = True
            '점이 포함되어 있을 경우
        ElseIf bDotContains Then

            '전체 길이 체크 정수부와 소수부의 길이 더하기 점의 길이보다 같거나 크면 받아들이지 않음.
            '또한, 이미 점이 포함되어 있으므로, 점이 들어오면 받아들이지 않음.
            If nTextLen >= nPreLen + nPostLen + 1 OrElse e.KeyChar = "." Then
                e.Handled = True
            Else
                '점의 위치를 구한다.
                Dim nDotPos As Integer = editor.Text.IndexOf(".")
                '텍스트를 정수부와 소수부로 나눈다.
                Dim sSep() As String = editor.Text.Split(".")

                '현재 커서가 점 앞에 있고, 정수부의 길이가 지정된 길이보다 길어지면 받아들이지 않음.
                If nDotPos > nCursor AndAlso sSep(0).Length >= nPreLen Then
                    e.Handled = True
                    '현재 커서가 점 뒤에 있고, 소수부의 길이가 지정된 길이보다 길어지면 받아들이지 않음.
                ElseIf nDotPos < nCursor AndAlso sSep(1).Length >= nPostLen Then
                    e.Handled = True
                End If
            End If
            '들어온 값이 점이 아니고, 현재 텍스트가 점을 포함하지 않으면
            '현재 값은 정수인데, 정수부의 길이가 지정된 길이보다 길어지면 받아들이지 않음.
        ElseIf Not e.KeyChar = "." AndAlso Not bDotContains AndAlso nTextLen >= nPreLen Then
            e.Handled = True
        End If

    End Sub
#End Region

End Module
